/*
** Generated by X-Designer
*/

/*
** X-Designer-generated prelude.
** Do not edit lines before "End of X-Designer generated prelude"
** Lines beginning ** X-Designer Stub indicate a stub
** which will not be output on re-generation
*/

/*
**LIBS: -lXm -lXt -lX11
*/

#include <stdlib.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>

#include "FontSelection.h"

/* End of X-Designer generated prelude */

#include <Xm/TextF.h>

/*
** Implements a menu bar allowing a user to select X fonts which follow the
** standard 14 part naming convention.
*/

#define FONT_MAGIC       587055
#define NLISTS           14        
#define LIST_SIZE        10        
#define STAR_ITEM         0         
#define MAX_FONT_NAME   512
#define NONE_TEXT       "<ʤ>"

static XrmQuark qstar = (XrmQuark) 0 ;

/*
** Compact way of storing font names - array of offsets into menu items
*/

typedef struct Font_s 
{
        short name[NLISTS] ;
} Font_t, *Font_p ;

/*
** Control structure for a Menu and Contents
*/

typedef struct List_s 
{
	Widget    menu ;
	Boolean   numeric_list ;
	Widget   *buttons ;
	XrmQuark *items ;
	char    **sorted_items ;
	short    *sorted_nums ;
	int       nItems ;
	int       selected ;
	Boolean  *sensitive ;
	Boolean   set_sensitive ;
} List_t, *List_p ;

/*
** Control structure for the whole dialog
*/

typedef struct FontDialogControlData_s *FontDialogControlData_p ;
typedef struct FontDialogControlData_s 
{
	unsigned long          magic ;
	font_selection_shell_p dialog ;
	Font_p                 font_data ;
	int                    font_count ;
	Cardinal               insert_position ;
	Widget                 widget_data[NLISTS] ;
	List_t                 list_data[NLISTS] ;
} FontDialogControlData_t ;

/*
** X-Designer Stub MenuOrderProcedure
*/

#ifndef   _NO_PROTO
static Cardinal MenuOrderProcedure(Widget widget)
#else  /* _NO_PROTO */
static Cardinal MenuOrderProcedure(widget)
        Widget widget ;
#endif /* _NO_PROTO */
{
	/*
	** Orders the Items in a Pulldown Menu
	*/

	FontDialogControlData_p fptr = (FontDialogControlData_p) 0 ;
	XtPointer               uptr = (XtPointer) 0 ;

	XtVaGetValues(widget, XmNuserData, &uptr, 0) ;

	if ((fptr = (FontDialogControlData_p) uptr) != (FontDialogControlData_p) 0) {
		return fptr->insert_position ;
	}

	return (Cardinal) 0 ;
}

/*
** X-Designer Stub MenuCascadeCallback
*/

#ifndef   _NO_PROTO
static void MenuCascadeCallback(Widget w, XtPointer client_data, XtPointer call_data)
#else  /* _NO_PROTO */
static void MenuCascadeCallback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XtPointer call_data ;
#endif /* _NO_PROTO */
{
	/*
	** Set the Sensitivities of items in a Pulldown Menu
	*/

	FontDialogControlData_p fptr = (FontDialogControlData_p) 0 ;
	XtPointer               uptr = (XtPointer) 0 ;
	List_p                  lptr = (List_p) 0 ;
	int                     i    = (int) client_data ;
	int                     j    = 0 ;

	XtVaGetValues(w, XmNuserData, &uptr, 0) ;

	if ((fptr = (FontDialogControlData_p) uptr) != (FontDialogControlData_p) 0) {
		lptr = &(fptr->list_data[i]) ;
		
		if (lptr->set_sensitive) {
			lptr->set_sensitive = False ;
		
			for (j = 1 ; j < lptr->nItems ; j++) {
				XtSetSensitive(lptr->buttons[j], lptr->sensitive[j]) ;
			}
		}
	}
}

/*
** X-Designer Stub CreatePulldownMenu
*/

#ifndef   _NO_PROTO
static Widget CreatePulldownMenu(FontDialogControlData_p fptr, char *name, Widget cascade, int index)
#else  /* _NO_PROTO */
static Widget CreatePulldownMenu(fptr, name, cascade, index)
	FontDialogControlData_p fptr ;
	char                   *name ;
	Widget                  cascade ;
	int                     index ;
#endif /* _NO_PROTO */
{
	/*
	** Creates a Pulldown Menu under the main font menubar
	*/

	Widget pulldown = (Widget) 0 ;
	Arg    argv[3] ;
	int    argc     = 0 ;

	XtSetArg(argv[argc], XmNradioBehavior,  True) ;               argc++ ;
	XtSetArg(argv[argc], XmNuserData,       (XtPointer) fptr) ;   argc++ ;
	XtSetArg(argv[argc], XtNinsertPosition, MenuOrderProcedure) ; argc++ ;

	pulldown = (Widget) XmCreatePulldownMenu(fptr->dialog->font_menubar, name, argv, argc) ;

	XtVaSetValues(cascade, XmNuserData, (XtPointer) fptr, XmNsubMenuId, pulldown, 0) ;
	XtAddCallback(cascade, XmNcascadingCallback, MenuCascadeCallback, (XtPointer) index) ;

	fptr->widget_data[index]    = cascade ;
	fptr->list_data[index].menu = pulldown ;

	return pulldown ;
}

/*
** X-Designer Stub CreateCascadeMenus
*/

#ifndef   _NO_PROTO
static Boolean CreateCascadeMenus(FontDialogControlData_p fptr)
#else  /* _NO_PROTO */
static Boolean CreateCascadeMenus(fptr)
	FontDialogControlData_p fptr ;
#endif  /* _NO_PROTO */
{
	/*
	** Simple loop over all the font cascades to create all the pulldowns
	*/

        Widget children[NLISTS] ;
	int    i = 0 ;

	children[i] = CreatePulldownMenu(fptr, "font_foundry_pulldown",  fptr->dialog->font_foundry,  i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_family_pulldown",   fptr->dialog->font_family,   i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_weight_pulldown",   fptr->dialog->font_weight,   i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_slant_pulldown",    fptr->dialog->font_slant,    i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_swidth_pulldown",   fptr->dialog->font_swidth,   i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_adstyle_pulldown",  fptr->dialog->font_adstyle,  i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_pixel_pulldown",    fptr->dialog->font_pixel,    i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_point_pulldown",    fptr->dialog->font_point,    i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_resX_pulldown",     fptr->dialog->font_resX,     i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_resY_pulldown",     fptr->dialog->font_resY,     i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_spc_pulldown",      fptr->dialog->font_spc,      i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_avwght_pulldown",   fptr->dialog->font_avwght,   i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_reg_pulldown",      fptr->dialog->font_reg,      i) ; i++ ;
	children[i] = CreatePulldownMenu(fptr, "font_encoding_pulldown", fptr->dialog->font_encoding, i) ; i++ ;

        XtManageChildren(children, i) ;

	return True ;
}

/*
** X-Designer Stub BuildFontName
*/

#ifndef   _NO_PROTO
static void BuildFontName(FontDialogControlData_p fptr, char *name)
#else  /* _NO_PROTO */
static void BuildFontName(fptr, name)
	FontDialogControlData_p fptr ;
	char                   *name ;
#endif /* _NO_PROTO */
{
	/*
	** Concatenates all the selected menu items into a single string
	*/

	int   i ;
        char *p = name ;
        char *q ;

        for (i = 0 ; i < NLISTS ; i++) {
                *p++ = '-' ;
                 q   = XrmQuarkToString(fptr->list_data[i].items[fptr->list_data[i].selected]) ;

                while (*q) {
                        *p++ = *q++ ;
		}
        }

        *p = 0 ;
}

/*
** X-Designer Stub EnableMenuButtons
*/

#ifndef   _NO_PROTO
static void EnableMenuButtons(FontDialogControlData_p fptr, char *fontName)
#else  /* _NO_PROTO */
static void EnableMenuButtons(fptr, fontName)
	FontDialogControlData_p fptr ;
        char                   *fontName ;
#endif /* _NO_PROTO */
{
	/*
	** Runs along the menu items setting their sensitivities
	** according to whether they match the chosen font
	*/

	int matchedFonts = 0 ;
	int i, j, k ;

        for (i = 0 ; i < NLISTS ; i++) {
		List_p list = &(fptr->list_data[i]) ;
		
		if (list->selected == STAR_ITEM) {
			list->set_sensitive = True ;
			
			for (j = 1 ; j < list->nItems ; j++) {
				list->sensitive[j] = 0 ;
				
				XmToggleButtonGadgetSetState(list->buttons[j], False, False) ;
			}
		}
		else {
                	list->set_sensitive = False ;
		}
        }

        for (k = 0 ; k < fptr->font_count ; k++) {
		short  *name    = fptr->font_data[k].name ;
		Boolean matched = True ;
		
		for (i = 0 ; i < NLISTS ; i++) {
			List_p list = &(fptr->list_data[i]) ;
			
			if ((list->selected != STAR_ITEM) && (list->selected != name[i])) {
				matched = False ;
				break ;
			}
		}
		
		if (matched) {
			matchedFonts++ ;
			
			for (i = 0 ; i < NLISTS ; i++) {
				List_p list = &(fptr->list_data[i]) ;

				list->sensitive[name[i]] = 1 ;
			}
		}
	}
}

/*
** X-Designer Stub ScalableFont
*/

#ifndef   _NO_PROTO
static Boolean ScalableFont(char *font_name)
#else  /* _NO_PROTO */
static Boolean ScalableFont(font_name)
	char *font_name ;
#endif /* _NO_PROTO */
{
	/*
	** Simple algorithm for deducing scalable font:
	**
	** If Average Weight/ Res X/ResY are zero, and the font
	** is fully specified in all parts, its probably scalable.
	*/

	register int i   = 0 ;
	register int seg = 0 ;
	
	if ((font_name == (char *) 0) || (*font_name != '-')) {
		return False ;
	}
	
	for (i = 0 ; font_name[i] != '\0' ; i++) {
		if (font_name[i] == '-') {
			++seg ;
			
			if ((seg == 7) || (seg == 8) || (seg == 12)) {
				if ((font_name[i + 1] != '0') || (font_name[i + 2] != '-')) {
					return False ;
				}
			}
		}
	}
	
	if (seg == 14) {
		return True ;
	}
	
	return False ;
}

/*
** X-Designer Stub LoadFontNames
*/

#ifndef   _NO_PROTO
static int LoadFontNames(char  *filter,
		         Widget list_widget,
			 Widget scalable_toggle,
			 Widget non_scalable_toggle)
#else  /* _NO_PROTO */
static int LoadFontNames(filter, list_widget, scalable_toggle, non_scalable_toggle)
	char  *filter ;
	Widget list_widget ;
	Widget scalable_toggle ;
	Widget non_scalable_toggle ;
#endif /* _NO_PROTO */
{
	/*
	** Resets the Font Names list depending on filter and scale toggles
	*/

	char    **name_list  = (char **) 0 ;
	int       name_count = 0 ;

	XmString *items      = (XmString *) 0 ;
	int       item_count = 0 ;

	Boolean   scaled     = XmToggleButtonGetState(scalable_toggle) ;
	Boolean   non_scaled = XmToggleButtonGetState(non_scalable_toggle) ;

	register  int i ;

	name_list = XListFonts(XtDisplay(list_widget), filter, 2048, &name_count) ;

	if (name_list != (char **) 0) {
		items = (XmString *) XtMalloc((unsigned) (name_count * sizeof(XmString))) ;
		
		for (i = 0 ; i < name_count ; i++) {
			Boolean required = False ;
			
			if (scaled && non_scaled) {
				required = True ;
			}
			else {
				if (ScalableFont(name_list[i])) {
		    			required = scaled ;
				}
				else {
		    			required = non_scaled ;
				}
			}

			if (required) {
				items[item_count++] = XmStringCreateLtoR(name_list[i], XmFONTLIST_DEFAULT_TAG) ;
			}
		}

		XFreeFontNames(name_list) ;
	}


	XtVaSetValues(list_widget, 
		      XmNitems,     items,
		      XmNitemCount, item_count, 
		      0) ;

	for (i = 0 ; i < item_count ; i++) {
		XmStringFree(items[i]) ;
	}

	XtFree((char *) items) ;

	return item_count ;
}

/*
** X-Designer Stub MenuItemCallback
*/

#ifndef   _NO_PROTO
static void MenuItemCallback(Widget w, XtPointer client_data, XmToggleButtonCallbackStruct *call_data)
#else  /* _NO_PROTO */
static void MenuItemCallback(w, client_data, call_data)
        Widget                        w ;
        XtPointer                     client_data ;
        XmToggleButtonCallbackStruct *call_data ;
#endif /* _NO_PROTO */
{
	/*
	** Called by each of the toggles in the font menus
	**
	** Refreshes the Names list according to the new filter
	*/

	FontDialogControlData_p fptr         = (FontDialogControlData_p) 0 ;
	XtPointer               uptr         = (XtPointer) 0 ;
        int                     listNum      = ((int) client_data) % NLISTS ;
        int                     selectedItem = ((int) client_data) / NLISTS ;
        char                    name[MAX_FONT_NAME + 1] ;

	XtVaGetValues(w, XmNuserData, &uptr, 0) ;

	if ((fptr = (FontDialogControlData_p) uptr) != (FontDialogControlData_p) 0) {
        	if (call_data->set) {
                	fptr->list_data[listNum].selected = selectedItem ;
			
			BuildFontName(fptr, name) ;
			EnableMenuButtons(fptr, name) ;
			
			(void) LoadFontNames(name,
					     fptr->dialog->font_selection_list,
					     fptr->dialog->font_name_scalable_toggle,
					     fptr->dialog->font_name_nonscalable_toggle) ;
        	}
        }
}

/*
** X-Designer Stub CreateMenuButton
*/

#ifndef   _NO_PROTO
static Widget CreateMenuButton(FontDialogControlData_p fptr, Widget parent, char *string, int value)
#else  /* _NO_PROTO */
static Widget CreateMenuButton(fptr, parent, string, value)
	FontDialogControlData_p fptr ;
        Widget                  parent ;
        char                   *string ;
        int                     value ;
#endif /* _NO_PROTO */
{
	/*
	** Creates a single Font Menu item.
	**
	** Misnamed somewhat: actually creates a toggle
	*/

        Widget button = (Widget) 0 ;
	Arg    argv[2] ;
	int    argc = 0 ;

        XmString xms = XmStringCreateLtoR(string, XmFONTLIST_DEFAULT_TAG) ;

        XtSetArg(argv[argc], XmNlabelString,            xms) ;  argc++ ;
        XtSetArg(argv[argc], XmNuserData,   (XtPointer) fptr) ; argc++ ;

        button = (Widget) XmCreateToggleButtonGadget(parent, "button", argv, argc) ;

        XtAddCallback(button, XmNvalueChangedCallback, MenuItemCallback, (XtPointer) value) ;

        XmStringFree(xms) ;

        return button ;
}

/*
** X-Designer Stub InList
*/

#ifndef   _NO_PROTO
static Boolean InList(FontDialogControlData_p fptr, int listNum, XrmQuark field, int *pos)
#else  /* _NO_PROTO */
static Boolean InList(fptr, listNum, field, pos)
	FontDialogControlData_p fptr ;
        int                     listNum ;
        XrmQuark                field ;
        int                    *pos ;
#endif /* _NO_PROTO */
{
	/*
	** Simple check to see if we have already added this item
	*/

        List_p list = &(fptr->list_data[listNum]) ;
        int    i ;

        for (i = 1 ; i < list->nItems ; i++) {
		if (list->items[i] == field) {
			*pos = i ;
			
			return True ;
		}
	}

        return False ;
}

/*
** X-Designer Stub AddToList
*/

#ifndef   _NO_PROTO
static int AddToList(FontDialogControlData_p fptr, int listNum, char *field)
#else  /* _NO_PROTO */
static int AddToList(fptr, listNum, field)
	FontDialogControlData_p fptr ;
        int                     listNum ;
        char                   *field ;
#endif /* _NO_PROTO */
{
	/*
	** Adds Items into the Font Menus
	*/

        List_p   list = &(fptr->list_data[listNum]) ;
        int      i ;
        char    *fieldText = field ;
        int      cmp ;
        short    numeric_value ;
        XrmQuark qfield ;

        if (!*field) {
            fieldText = NONE_TEXT ;
	}

        qfield                = XrmStringToQuark(fieldText) ;
        fptr->insert_position = list->nItems ;

        if (list->numeric_list) { 
		numeric_value = atoi(field) ;
	}

        if (qfield != qstar) {
            int pos ;

            if (InList(fptr, listNum, qfield, &pos)) {
                return pos ;
	    }

            for (i = 1 ; i < list->nItems ; i++) {
                if (list->numeric_list) {
                    if (list->sorted_nums[i] == numeric_value) {
                        cmp = 0 ;
		    }
                    else if ((short) list->sorted_nums[i] > numeric_value) {
                        cmp = 1 ;
		    }
                    else {
                        cmp = -1 ;
		    }
		}
                else {
                    cmp = strcmp(list->sorted_items[i], field) ;
		}

                /* cmp can't be 0 */

                if (cmp > 0) {
                    /* Make "" come after "*" */

                    if (!*field) {
                        fptr->insert_position = 1 ;
		    }
                    else {
                        fptr->insert_position = i ;
		    }

                    break ;
                }
            }
        }

        if (list->nItems == 0) {
                list->items = (XrmQuark *) malloc(LIST_SIZE * sizeof(XrmQuark)) ;

                if (list->numeric_list) {
                    list->sorted_nums  = (short *) malloc(LIST_SIZE * sizeof(short)) ;
		}
                else {
                    list->sorted_items = (char **) malloc(LIST_SIZE * sizeof(char *)) ;
		}

                list->buttons = (Widget *) malloc(LIST_SIZE * sizeof(Widget)) ;
        } else if (list->nItems % LIST_SIZE == 0) {
                list->items = (XrmQuark *) realloc(list->items, (list->nItems + LIST_SIZE) * sizeof(XrmQuark)) ;

                if (list->numeric_list) {
                    list->sorted_nums = (short *)realloc(list->sorted_nums, (list->nItems + LIST_SIZE) * sizeof(short)) ;
		}
                else {
                    list->sorted_items = (char **)realloc(list->sorted_items, (list->nItems + LIST_SIZE) * sizeof(char *)) ;
		}

                list->buttons = (Widget *)realloc(list->buttons, (list->nItems + LIST_SIZE) * sizeof(Widget)) ;
        }

        if ( list->numeric_list ) {
            for (i = list->nItems ; i > fptr->insert_position ; i--) {
                list->sorted_nums[i] = list->sorted_nums[i - 1] ;
	    }

            list->sorted_nums[fptr->insert_position] = numeric_value ;
        }
        else {
            for ( i = list->nItems ; i > fptr->insert_position ; i--) {
                list->sorted_items[i] = list->sorted_items[i - 1] ;
	    }

            list->sorted_items[fptr->insert_position] = field ;
        }

        list->items[list->nItems]   = qfield ;
        list->buttons[list->nItems] = CreateMenuButton(fptr, list->menu, fieldText, list->nItems * NLISTS + listNum) ;

        if (list->nItems == 0) {
                XmToggleButtonGadgetSetState(list->buttons[0], True, False) ;
	}

        return list->nItems++ ;
}

/*
** X-Designer Stub SplitFontName
*/

#ifndef   _NO_PROTO
static void SplitFontName(char *name, char **fields)
#else  /* _NO_PROTO */
static void SplitFontName(name, fields)
        char  *name ;
        char **fields ;
#endif /* _NO_PROTO */
{
	/*
	** Reverse of BuildFontName: tokenises the font name into parts
	*/

        register int i = 0 ;

        for ( ; *name ; name++) {
                if (*name == '-') {
                        *name = 0 ;

                        if ((0 <= i) && (i <= NLISTS)) {
                                fields[i] = name + 1 ;
			}

                        i++ ;
                }
        }
}

/*
** X-Designer Stub LoadFontMenus
*/

#ifndef   _NO_PROTO
static Boolean LoadFontMenus(Display *display, FontDialogControlData_p fptr)
#else  /* _NO_PROTO */
static Boolean LoadFontMenus(display, fptr)
        Display                *display ;
	FontDialogControlData_p fptr ;
#endif /* _NO_PROTO */
{
	/*
	** Higher order menu fill function: 
	**
	** Fetches the X font list, and loads all the menus accordingly
	*/

        char **fontNames = (char **) 0 ;
        char  *fields[NLISTS] ;
        int    i, field ;

        fontNames       = XListFonts(display, "-*", 2048, &fptr->font_count) ;
        fptr->font_data = (Font_t *) malloc((unsigned) (fptr->font_count * sizeof(Font_t))) ;

        if (fptr->font_data == (Font_p) 0) {
		XFreeFontNames(fontNames) ;
		
		return False ;
        }

	if (qstar == (XrmQuark) 0) {
        	qstar = XrmStringToQuark("*") ;
	}

        for (field = 0 ; field < NLISTS ; field++) {
                (void) AddToList(fptr, field, "*") ;
	}

        for (i = 0 ; i < fptr->font_count ; i++) {
                short *name = fptr->font_data[i].name ;

                SplitFontName(fontNames[i], fields) ;

                for (field = 0 ; field < NLISTS ; field++) {
                        name[field] = AddToList(fptr, field, fields[field]) ;
		}
        }

        for (field = 0 ; field < NLISTS ; field++) {
		if (fptr->list_data[field].nItems ) {
                	XtManageChildren(fptr->list_data[field].buttons, fptr->list_data[field].nItems) ;
		}
	}

        for (field = 0 ; field < NLISTS ; field++) {
		if (fptr->list_data[field].numeric_list) {
                	XtFree((char *) fptr->list_data[field].sorted_nums) ;
		} 
		else {
                	XtFree((char *) fptr->list_data[field].sorted_items) ;
		}

		fptr->list_data[field].sensitive     = (Boolean *) XtMalloc(fptr->list_data[field].nItems) ;
		fptr->list_data[field].set_sensitive = False ;
        }

        XFreeFontNames(fontNames) ;

	return True ;
}

/*
** X-Designer Stub ConvertStringToFontList
*/

#ifndef   _NO_PROTO
static XmFontList ConvertStringToFontList(Widget widget, char *font_name)
#else  /* _NO_PROTO */
static XmFontList ConvertStringToFontList(widget, font_name)
	Widget widget ;
	char  *font_name ;
#endif /* _NO_PROTO */
{
	/*
	** Cheap and cheerful: given a font name, convert to XmFontList
	** for applying to the sample text
	*/

	XrmValue from_value ;
	XrmValue to_value ;

	from_value.size = strlen(font_name) + 1 ;
	from_value.addr = font_name ;
	to_value.addr   = NULL ;
	
	XtConvertAndStore(widget, XmRString, &from_value, XmRFontList, &to_value) ;

	if (to_value.addr) {
		return *(XmFontList *) to_value.addr ;
	}

	return (XmFontList) 0 ;
}

/*
** X-Designer Stub font_name_list_callback
*/

#ifndef   _NO_PROTO
void font_name_list_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_name_list_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmListCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmListCallbackStruct *call_data = (XmListCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */

	/*
	** Callback when user selects a name from the font names list
	**
	** Simply put the value in selection field, and apply to the sample text
	*/

	font_selection_shell_p fptr = (font_selection_shell_p) client_data ;
	XmString               item = call_data->item ;
	char                  *font = (char *) 0 ;
	XmFontList             fl   = (XmFontList) 0 ;

	if (item != (XmString) 0) {
		if (XmStringGetLtoR(item, XmFONTLIST_DEFAULT_TAG, &font)) {
			XmTextFieldSetString(fptr->font_selection_text, font) ;

			if ((fl = ConvertStringToFontList(fptr->font_sample_text, font)) != (XmFontList) 0) {
				XtVaSetValues(fptr->font_sample_text, XmNfontList, fl, 0) ;
			}

			XtFree(font) ;
		}
	}
}

/*
** X-Designer Stub font_ok_callback
*/

#ifndef   _NO_PROTO
void font_ok_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_ok_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmPushButtonCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmPushButtonCallbackStruct *call_data = (XmPushButtonCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */

	/*
	** FIXME:
	**
	** Handle the collected selection here
	*/

	font_selection_shell_p fptr      = (font_selection_shell_p) client_data ;
	char                  *selection = XmTextFieldGetString(fptr->font_selection_text) ;

	XtFree(selection) ;
}

/*
** X-Designer Stub font_all_callback
*/

#ifndef   _NO_PROTO
void font_all_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_all_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmPushButtonCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmPushButtonCallbackStruct *call_data = (XmPushButtonCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */

	/*
	** All Fonts button selected
	**
	** Reset all the menu items to the star entry, reset sensitivities, and reload the fonts
	*/

	font_selection_shell_p  fptr  = (font_selection_shell_p) client_data ;
	FontDialogControlData_p fdptr = (FontDialogControlData_p) 0 ;
	XtPointer               uptr  = (XtPointer) 0 ;
	int                     i ;

	XtVaGetValues(w, XmNuserData, &uptr, 0) ;

	fdptr = (FontDialogControlData_p) uptr ;

	for (i = 0 ; i < NLISTS; i++) {
		List_p list = &(fdptr->list_data[i]) ;
		
		if (list->selected != STAR_ITEM) {
			XmToggleButtonSetState(list->buttons[list->selected], False, False) ;
			XmToggleButtonSetState(list->buttons[STAR_ITEM],      True, False) ;
			
			list->selected = STAR_ITEM ;
		}
	}
	
	EnableMenuButtons(fdptr, "*") ;

	(void) LoadFontNames("*", 
			     fptr->font_selection_list, 
			     fptr->font_name_scalable_toggle, 
			     fptr->font_name_nonscalable_toggle) ;
}

/*
** X-Designer Stub font_cancel_callback
*/

#ifndef   _NO_PROTO
void font_cancel_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_cancel_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmPushButtonCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmPushButtonCallbackStruct *call_data = (XmPushButtonCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */

	/*
	** Simple Popdown
	*/

	font_selection_shell_p fptr = (font_selection_shell_p) client_data ;

	XtUnmanageChild(fptr->font_dialog) ;
}

/*
** X-Designer Stub font_help_callback
*/

#ifndef   _NO_PROTO
void font_help_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_help_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmPushButtonCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmPushButtonCallbackStruct *call_data = (XmPushButtonCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */
	/*
	** FIXME:
	**
	** Handle the dialog help here
	*/

	font_selection_shell_p fptr = (font_selection_shell_p) client_data ;
}

/*
** X-Designer Stub font_name_scalable_callback
*/

#ifndef   _NO_PROTO
void font_name_scalable_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_name_scalable_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmToggleButtonCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmToggleButtonCallbackStruct *call_data = (XmToggleButtonCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */

	/*
	** Just filter the Names list for scalable fonts that match the existing criteria
	*/

	font_selection_shell_p  fptr  = (font_selection_shell_p) client_data ;
	FontDialogControlData_p fdptr = (FontDialogControlData_p) 0 ;
	XtPointer               uptr  = (XtPointer) 0 ;
	char                    name[MAX_FONT_NAME + 1] ;

	XtVaGetValues(w, XmNuserData, &uptr, 0) ;

	fdptr = (FontDialogControlData_p) uptr ;
	
	BuildFontName(fdptr, name) ;

	(void) LoadFontNames(name,
			     fptr->font_selection_list, 
			     fptr->font_name_scalable_toggle, 
			     fptr->font_name_nonscalable_toggle) ;
}

/*
** X-Designer Stub font_name_nonscalable_callback
*/

#ifndef   _NO_PROTO
void font_name_nonscalable_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
#else  /* _NO_PROTO */
void font_name_nonscalable_callback(w, client_data, call_data)
	Widget    w ;
	XtPointer client_data ;
	XmToggleButtonCallbackStruct * call_data ;
#endif /* _NO_PROTO */
{
#ifndef   _NO_PROTO
	XmToggleButtonCallbackStruct *call_data = (XmToggleButtonCallbackStruct *) xt_call_data ;
#endif /* _NO_PROTO */

	/*
	** As above: filter the Names list for scalable fonts that match the existing criteria
	*/

	font_selection_shell_p  fptr  = (font_selection_shell_p) client_data ;
	FontDialogControlData_p fdptr = (FontDialogControlData_p) 0 ;
	XtPointer               uptr  = (XtPointer) 0 ;
	char                    name[MAX_FONT_NAME + 1] ;

	XtVaGetValues(w, XmNuserData, &uptr, 0) ;
	
	fdptr = (FontDialogControlData_p) uptr ;
	
	BuildFontName(fdptr, name) ;
	
	(void) LoadFontNames(name,
			     fptr->font_selection_list, 
			     fptr->font_name_scalable_toggle, 
			     fptr->font_name_nonscalable_toggle) ;
}


/*
** X-Designer Stub InitialiseFontDialog
*/

#ifndef   _NO_PROTO
Boolean InitialiseFontDialog(font_selection_shell_p fptr)
#else  /* _NO_PROTO */
Boolean InitialiseFontDialog(fptr)
	font_selection_shell_p fptr ;
#endif /* _NO_PROTO */
{
	/*
	** Create the control structure if required, fill the lists and menus
	*/

	register FontDialogControlData_p fdptr ;
	register int                     i ;
		 XtPointer               user_data = (XtPointer) 0 ;

	XtVaSetValues(fptr->font_all_button, XmNuserData, &user_data, 0) ;

	fdptr = (FontDialogControlData_p) user_data ;

	if ((fdptr != (FontDialogControlData_p) 0) && (fdptr->magic == FONT_MAGIC)) {
		return True ;
	}
	
	fdptr = (FontDialogControlData_p) XtMalloc((unsigned) sizeof(FontDialogControlData_t)) ;

	fdptr->magic           = FONT_MAGIC ;
	fdptr->dialog          = fptr ;
	fdptr->font_data       = (Font_p) 0 ;
	fdptr->font_count      = 0 ;
	fdptr->insert_position = 0 ;

	for (i = 0 ; i < NLISTS ; i++) {
		fdptr->widget_data[i]             = (Widget) 0 ;
		fdptr->list_data[i].menu          = (Widget) 0 ;
		fdptr->list_data[i].numeric_list  = False ;
		fdptr->list_data[i].buttons       = (Widget *) 0 ;
		fdptr->list_data[i].items         = (XrmQuark *) 0 ;
		fdptr->list_data[i].sorted_items  = (char **) 0 ;
		fdptr->list_data[i].sorted_nums   = (short *) 0 ;
		fdptr->list_data[i].nItems        = 0 ;
		fdptr->list_data[i].selected      = 0 ;
		fdptr->list_data[i].sensitive     = (Boolean *) 0  ;
		fdptr->list_data[i].set_sensitive = False ;
	}

	XtVaSetValues(fptr->font_all_button,              XmNuserData, (XtPointer) fdptr, 0) ;
	XtVaSetValues(fptr->font_name_scalable_toggle,    XmNuserData, (XtPointer) fdptr, 0) ;
	XtVaSetValues(fptr->font_name_nonscalable_toggle, XmNuserData, (XtPointer) fdptr, 0) ;

	(void) CreateCascadeMenus(fdptr) ;
	(void) LoadFontMenus(XtDisplay(fptr->font_selection_shell), fdptr) ;
	(void) LoadFontNames("*", 
			     fptr->font_selection_list, 
			     fptr->font_name_scalable_toggle, 
			     fptr->font_name_nonscalable_toggle) ;

	return True ;
}
